import java.io.StreamTokenizer;
import java.util.StringTokenizer;
import java.io.StringReader;

public class Context{

	private String firstName;
	private String lastName;
	private String focus;
	private String answerString;
	private Record record;
	private boolean bus;						//Determines if topic is bus

	public Context(){
		record = new Record("");
	}

	public void parseNewAnswer(String s){

		resetContext();
		boolean inContextField = false;
		boolean inAttributesField = false;
		boolean inFocusField = false;
		boolean inFrameField = false;

		StreamTokenizer st = new StreamTokenizer(new StringReader(s));

		try{
			while(st.ttype != StreamTokenizer.TT_EOF){
				if(st.sval != null && st.sval.equals("Context")){
					inContextField = true;
				}

				if(inContextField && st.sval != null && st.sval.equals("focus")){
					inFocusField = true;
				}
				else if(inContextField && st.sval != null && st.sval.equals("frame")){
					inFrameField = true;
				}
				else if(inContextField && inFrameField && st.sval != null && st.sval.equals("attributes")){
					inAttributesField = true;
				}

				if(st.sval != null && st.sval.equals("topic")){												//Check for topic bus
					st.nextToken();
					if(st.sval != null && st.sval.equals("bus")){
						bus = true;
						extractAnswerString(s);
					}
				}

				if(inContextField && inFocusField){
					boolean goOn = true;
					boolean getFocus = false;
					while(goOn){
						if(st.sval != null && st.sval.equals("frame")){
							inFocusField = false;
							inFrameField = true;
							goOn = false;
						}
						else if(st.sval != null && st.sval.equals("attributes")){
							goOn = false;
							getFocus = true;
						}
						st.nextToken();
					}
					if(getFocus){
						st.nextToken();
						st.nextToken();
						focus = st.sval;
						inFocusField = false;
					}
				}
				else if(inContextField && inFrameField && inAttributesField){
					if(st.sval != null && st.sval.equals("givenname")){
						st.nextToken();
						firstName = st.sval;
					}
					if(st.sval != null && st.sval.equals("sn")){
						st.nextToken();
						lastName = st.sval;
					}
					if(st.sval != null && st.sval.equals("itemsfound")){
						inAttributesField = false;
					}
				}
				st.nextToken();
			}
		}
		catch(Exception e){
			System.out.println("Exception while performing nextToken() in Context.parseNewAnswer():");
			System.out.println(e.toString());
		}
		record = new Record(s);
	}

	private void extractAnswerString(String s){
		StringTokenizer st = new StringTokenizer(s);
		boolean inAnswerField = false;
		answerString = "";
		while(st.hasMoreTokens()){
			if(st.nextToken().equals("Answer")){
				boolean done = false;
				while(!done){
					String tempo = st.nextToken();
					if(tempo.equals("Context")) done=true;
					else if(tempo.equals("***")){}
					else answerString += tempo+" ";
				}
			}
		}
	}

	public boolean bus(){
		if(!answerString.equals("")) return bus;
		return false;
	}

	public boolean personFound(){
		if(record.personFound()) return true;
		else return false;
	}

	public boolean missingInformation(){
		if(( (firstName!=null && lastName==null)||(firstName==null && lastName!=null) )&& focus!=null) return true;
		else return false;
	}

	public String getAnswerString(){
		return answerString;
	}

	public String getFirstName(){
		return firstName;
	}

	public String getLastName(){
		return lastName;
	}

	public String getName(){
		return firstName+" "+lastName;
	}

	public String getDepartment(){
		return record.getDepartment();
	}

	public String getFullName(){
		return record.getFullName();
	}

	public int getPhoneNumber(){
		return record.getPhoneNumber();
	}

	public String getBuilding(){
		return record.getBuilding();
	}

	public String getRoomNumber(){
		return record.getRoomNumber();
	}

	public String getTitle(){
		return record.getTitle();
	}

	public String getStreet(){
		return record.getStreet();
	}

	public String getRecordString(){
		return record.recordString();
	}

	public String getFocus(){
		return focus;
	}

	public Record getRecord(){
		return (Record)record.clone();
	}

	private void resetContext(){
		firstName = null;
		lastName = null;
		focus = null;
		bus = false;
		answerString = "";
	}
}