import java.awt.*;
import javax.swing.*;
import java.awt.geom.*;
import java.util.ArrayList;
import java.lang.Thread;


public class It3Map extends JLabel{

	private int[][] mapCoords = {
								{ 1, 103, 41},
								{ 2, 84, 56},
								{ 3, 84,87},
								{ 4, 84,132},
								{ 5, 84,158},
								{ 6, 84,179},
								{ 7, 84,214},
								{ 8, 84,242},
								{10, 84,303},
								{11, 84,336},
								{12, 84,365},
								{13, 84,399},
								{14, 84,424},
								{15, 84,454},
								{16, 84,486},
								{17, 84,520},
								{20, 84,609},
								{21, 84,644},
								{22, 84,671},
								{25, 90,717},
								{24, 48,719},
								{26, 102,720},
								{63, 120,689},
								{61, 145,624},
								{60, 163,603},
								{59, 162,586},
								{58, 120,546},
								{56, 120,489},
								{54, 120,424},
								{35, 120,369},
								{32, 120,322},
								{31, 120,304},
								{33,130,330},
								{34,145,354},
								{36,160,354},
								{37,175,354},
								{30,135,269},
								{42, 121, 54},
								{43,159,80},
								{44,159,111},
								{45,159,142},
								{46,159,173},
								{47,159,203},
								{48,219,237},
								{49,224,269},
								{50,231,303},
								{90,134,241},
								{99,63,725}
											};

	ImageIcon it3;
	private Ellipse2D.Double circle;
	private Ellipse2D.Double startDot;
	private Line2D.Double youreHereLine;
	private Line2D.Double goalLine;

	private ArrayList pathList;
	private int goalText_y;
	private int tempX;
	private int tempY;

	private boolean showGoal;

	public It3Map(String roomNumber){
		super(new ImageIcon("it3.jpg"));
		int[] locationCoords = new int[2];
		int nr = Integer.parseInt(roomNumber)-300;
		for(int i=0; i<mapCoords.length; i++){
			if(mapCoords[i][0] == nr){
				locationCoords[0] = mapCoords[i][1];
				locationCoords[1] = mapCoords[i][2];
			}
		}
		setLocationCircle(locationCoords[0]-25,locationCoords[1]-15);
		startDot = new Ellipse2D.Double(85,712,10,10);
		youreHereLine = new Line2D.Double(90,717,400,717);
		tempX = 75;
		tempY = 815;
		showGoal = true;
	}

	public It3Map(){
		super(new ImageIcon("it3.jpg"));
		int[] locationCoords = new int[2];
		startDot = new Ellipse2D.Double(85,712,10,10);
		youreHereLine = new Line2D.Double(90,717,400,717);
		tempX = 75;
		tempY = 815;
		showGoal = false;
	}

	public void paintComponent(Graphics g){
		clear(g);
		Graphics2D g2d = (Graphics2D)g;
		g2d.setColor(Color.red);
		if(showGoal){
			g2d.draw(circle);
			g2d.draw(goalLine);
			g2d.drawString("Du skal hit!", 360, goalText_y);
		}
		g2d.fill(startDot);
		g2d.draw(youreHereLine);
		g2d.drawString("Du er her!", 360, 710);

		g2d.setColor(Color.green);
	}

	public void setLocationCircle(int x, int y){
		circle = new Ellipse2D.Double(x,y,50,30);
		goalLine = new Line2D.Double(x+50, y+15, 400, y+15);
		goalText_y = y+5;
	}

	protected void clear(Graphics g){
		super.paintComponent(g);
	}

	protected Ellipse2D.Double getCircle(){
		return (circle);
	}
}





