import se.sics.jasper.*;
import java.util.HashMap;
import java.io.*;

public class PrologConnection{

	private Prolog p;
	private MarvinDialog md;
	private FileWriter fw;
	private FileReader fr;

	private String questionFile;
	private String answerFile;
	private String currentDir;


	public PrologConnection(Prolog p, MarvinDialog md, String qF, String aF){
		this.p = p;
		this.md = md;
		this.questionFile = qF;
		this.answerFile = aF;

		File dir1 = new File (".");
		currentDir = "";
		try {
			currentDir = dir1.getCanonicalPath();
		}
		catch(Exception e) {
			e.printStackTrace();
		}

		StringBuffer sb = new StringBuffer(currentDir);
		for(int i=0; i<sb.length(); i++){
			Character newChar = new Character(sb.charAt(i));
			if( newChar.equals('\\') ){
				sb.setCharAt(i, '/');
			}
		}

		currentDir = sb.toString();
	}

	/**
	*	Method for processing queries to Telebuster.
	*/
	public String processQuery(String s){

	//Write question to question file
		try{
			fw = new FileWriter(currentDir+questionFile);
		}
		catch(IOException e){
			System.out.println("IOException trying to open filewriter for "+currentDir+questionFile+": \n");
			System.out.println(e.toString());
		}
		try{
			fw.write(s);
		}
		catch(IOException e){
			System.out.println("IOException trying to write "+currentDir+questionFile+": \n");
			System.out.println(e.toString());
		}
		try{
			fw.close();
		}
		catch(Exception e){
			System.out.print("Exception trying to close filewriter for "+currentDir+questionFile+": \n");
			System.out.println(e.toString());
		}

	//Write default answer to answer file
		try{
				fw = new FileWriter(currentDir+answerFile);
			}
			catch(IOException e){
				System.out.println("IOException trying to open filewriter for "+currentDir+answerFile+": \n");
				System.out.println(e.toString());
			}
			try{
				fw.write("no answer");
			}
			catch(IOException e){
				System.out.println("IOException trying to write "+currentDir+answerFile+": \n");
				System.out.println(e.toString());
			}
			try{
				fw.close();
			}
			catch(Exception e){
				System.out.println(e.toString());
		}

	//Perform query
		try{
			p.query("direct_run('" + currentDir+questionFile + "','" + currentDir+answerFile + "').", null);
		}
		catch(Exception e){
			System.out.println("Exception while querying 'direct_run('" + currentDir+questionFile + "','" + currentDir+answerFile + "').:");
			System.out.println(e.toString());
		}

		String result = readAnswer();

		return result;
	}

	/**
	*	Reads answer from the answer file.
	*/
	public String readAnswer(){

		String result = "";

	//Read from newans
		try{
			fr = new FileReader(currentDir+answerFile);
		}
		catch(IOException e){
			System.out.println("IOException trying to open filereader for newans:");
			System.out.println(e.toString());
		}
		File infile = new File(currentDir+answerFile);
		char[] cbuf = new char[(int)infile.length()];
		try{
			fr.read(cbuf);
		}
		catch(IOException e){
			System.out.println(e.toString());
		}
		try{
			fr.close();
		}
		catch(Exception e){
			System.out.println(e.toString());
		}
		for(int i=0; i<cbuf.length; i++){
			result += cbuf[i];
		}

	//Return the result
		return result;
	}
}