import java.io.StreamTokenizer;
import java.io.StringReader;
import java.lang.*;


public class Record implements Cloneable{

	private boolean personFound;

	private String department;
	private String fullName;
	private int phoneNumber;
	private String building;
	private String roomNumber;
	private String title;
	private String street;

	public Record(String s){

		extractDepartment(s);
		extractName(s);
		phoneNumber = 0;
		extractPhone(s);
		extractBuildingAndRoom(s);
		extractTitle(s);
		extractStreet(s);
		personFound = personFound(s);
	}

	private boolean personFound(String s){
		if(fullName.equals("")) return false;
		else return true;
	}

	private void extractDepartment(String s){
		department = "";
		try{
			StreamTokenizer st = new StreamTokenizer(new StringReader(s));
			st.ordinaryChar(' ');

			while(!(st.sval != null && st.sval.equals("record")) && st.ttype != StreamTokenizer.TT_EOF){
				st.nextToken();
			}
			while(!(st.sval != null && st.sval.equals("ou")) && st.ttype != StreamTokenizer.TT_EOF){
				st.nextToken();
			}
			while(!(st.sval != null && st.sval.equals("cn")) && st.ttype != StreamTokenizer.TT_EOF){
				if(st.sval != null && st.sval.equals("ou")) department += "\n";
				else if(st.sval != null) department += st.sval;
				if(st.ttype == ' ') department += " ";
				st.nextToken();
			}
		}
		catch(Exception e){
			System.out.println(e.toString());
		}
	}

	private void extractName(String s){
			fullName = "";
			try{
				StreamTokenizer st = new StreamTokenizer(new StringReader(s));
				st.ordinaryChar(' ');
				st.ordinaryChar(',');

				while(!(st.sval != null && st.sval.equals("record")) && st.ttype != StreamTokenizer.TT_EOF){
					st.nextToken();
				}
				while(!(st.sval != null && st.sval.equals("cn")) && st.ttype != StreamTokenizer.TT_EOF){
					st.nextToken();
				}
				st.nextToken();
				while(st.ttype != ',' && st.ttype != StreamTokenizer.TT_EOF){
					if(st.sval != null) fullName += st.sval;
					if(st.ttype == ' ') fullName += " ";
					st.nextToken();
				}
			}
			catch(Exception e){
				System.out.println(e.toString());
			}
	}

	private void extractPhone(String s){
			try{
				StreamTokenizer st = new StreamTokenizer(new StringReader(s));
				st.ordinaryChar(',');

				while(!(st.sval != null && st.sval.equals("record")) && st.ttype != StreamTokenizer.TT_EOF){
					st.nextToken();
				}
				while(!(st.sval != null && st.sval.equals("telephonenumber")) && st.ttype != StreamTokenizer.TT_EOF){
					st.nextToken();
				}
				while(st.ttype != ',' && st.ttype != StreamTokenizer.TT_EOF){
					if(st.ttype == StreamTokenizer.TT_NUMBER) phoneNumber = (int)st.nval;
					st.nextToken();
				}
			}
			catch(Exception e){
				System.out.println(e.toString());
			}
	}

	private void extractBuildingAndRoom(String s){
				building = "";
				roomNumber = "";
				try{
					StreamTokenizer st = new StreamTokenizer(new StringReader(s));
					st.ordinaryChar(' ');
					st.ordinaryChar(',');
					st.ordinaryChar('*');
					st.ordinaryChar('-');
					st.ordinaryChar('0');
					st.ordinaryChar('1');
					st.ordinaryChar('2');
					st.ordinaryChar('3');
					st.ordinaryChar('4');
					st.ordinaryChar('5');
					st.ordinaryChar('6');
					st.ordinaryChar('7');
					st.ordinaryChar('8');
					st.ordinaryChar('9');

					while(!(st.sval != null && st.sval.equals("record")) && st.ttype != StreamTokenizer.TT_EOF){
						st.nextToken();
					}
					while(!(st.sval != null && st.sval.equals("roomnumber")) && st.ttype != StreamTokenizer.TT_EOF){
						st.nextToken();
					}
					st.nextToken();
					while(st.ttype != '*' && st.ttype != StreamTokenizer.TT_EOF){
						if(st.sval != null) building += st.sval;
						else if(st.ttype == ' ') building += " ";
						else if(st.ttype == '-') building += "-";
						st.nextToken();
					}
					while(st.ttype != ',' && st.ttype != StreamTokenizer.TT_EOF){
						if(st.ttype == '0') roomNumber += "0";
						if(st.ttype == '1') roomNumber += "1";
						if(st.ttype == '2') roomNumber += "2";
						if(st.ttype == '3') roomNumber += "3";
						if(st.ttype == '4') roomNumber += "4";
						if(st.ttype == '5') roomNumber += "5";
						if(st.ttype == '6') roomNumber += "6";
						if(st.ttype == '7') roomNumber += "7";
						if(st.ttype == '8') roomNumber += "8";
						if(st.ttype == '9') roomNumber += "9";
						st.nextToken();
					}
				}
				catch(Exception e){
					System.out.println(e.toString());
				}

		if(building.startsWith("Dragv")) building = "Dragvoll";
	}

	private void extractTitle(String s){
				title = "";
				try{
					StreamTokenizer st = new StreamTokenizer(new StringReader(s));
					st.ordinaryChar(',');
					st.ordinaryChar(' ');

					while(!(st.sval != null && st.sval.equals("record")) && st.ttype != StreamTokenizer.TT_EOF){
						st.nextToken();
					}
					while(!(st.sval != null && st.sval.equals("title")) && st.ttype != StreamTokenizer.TT_EOF){
						st.nextToken();
					}
					st.nextToken();
					while(st.ttype != ',' && st.ttype != StreamTokenizer.TT_EOF){
						if(st.sval != null) title += st.sval;
						else if(st.ttype == ' ') title += " ";
						st.nextToken();
					}
				}
				catch(Exception e){
					System.out.println(e.toString());
				}
	}

	private void extractStreet(String s){
					street = "";
					try{
						StreamTokenizer st = new StreamTokenizer(new StringReader(s));
						st.ordinaryChar(',');
						st.ordinaryChar(' ');
						st.ordinaryChar('.');

						while(!(st.sval != null && st.sval.equals("record")) && st.ttype != StreamTokenizer.TT_EOF){
							st.nextToken();
						}
						while(!(st.sval != null && st.sval.equals("street")) && st.ttype != StreamTokenizer.TT_EOF){
							st.nextToken();
						}
						st.nextToken();
						while(st.ttype != ']' && st.ttype != StreamTokenizer.TT_EOF){
							if(st.sval != null) street += st.sval;
							else if(st.ttype == ' ') street += " ";
							else if(st.ttype == '.') street += ".";
							else if(st.ttype == StreamTokenizer.TT_NUMBER) street += (int)st.nval;
							st.nextToken();
						}
					}
					catch(Exception e){
						System.out.println(e.toString());
					}
	}

	public String recordString(){
		return fullName+department+"\nTelefonnummer: "+phoneNumber+"\nKontor: "+roomNumber+" i "+building+"\nStilling: "+title+"\nAdresse: "+street;
	}

	public String getDepartment(){
		return department;
	}

	public String getFullName(){
		return fullName;
	}

	public int getPhoneNumber(){
		return phoneNumber;
	}

	public String getBuilding(){
		if(building=="") return street;
		else return building;
	}

	public String getRoomNumber(){
		return roomNumber;
	}

	public String getTitle(){
		return title;
	}

	public String getStreet(){
		return street;
	}

	public boolean personFound(){
		return personFound;
	}

	public Object clone(){
		try{
			return super.clone();
		}
		catch(Exception e){

		}
		return null;
	}
}