import java.awt.*;
import javax.swing.*;
import java.awt.geom.*;
import java.util.ArrayList;
import java.lang.Thread;


public class TrondheimMap extends JLabel{

	private String[][] mapCoords = {
								{"Dragvoll", "325", "230"}
											};

	ImageIcon it3;
	private Ellipse2D.Double circle;
	private Ellipse2D.Double startDot;
	private Line2D.Double youreHereLine;
	private Line2D.Double goalLine;

	private ArrayList pathList;
	private int goalText_y;
	private boolean locationFound = false;

	public TrondheimMap(String location){
		super(new ImageIcon("trondheim.jpg"));
		int[] locationCoords = new int[2];
		for(int i=0; i<mapCoords.length; i++){
			if( ((String)mapCoords[i][0]).equals(location)){
				locationCoords[0] = Integer.parseInt(mapCoords[i][1]);
				locationCoords[1] = Integer.parseInt(mapCoords[i][2]);
				locationFound = true;
			}
		}
		if(locationFound) setLocationCircle(locationCoords[0]-25,locationCoords[1]-15);
		startDot = new Ellipse2D.Double(173,178,10,10);
		youreHereLine = new Line2D.Double(178,183,515,183);
	}

	//Dummy constructor
	public TrondheimMap(){

	}

	public boolean buildingInTrondheim(String s){
		for(int i=0; i<mapCoords.length; i++){
			if(s.equals(mapCoords[i][0])) return true;
		}
		return false;
	}

	public void paintComponent(Graphics g){
		clear(g);
		Graphics2D g2d = (Graphics2D)g;
		g2d.setColor(Color.red);
		if(locationFound){
			g2d.draw(circle);
			g2d.draw(goalLine);
			g2d.drawString("Du skal hit!", 465, goalText_y);
		}
		g2d.fill(startDot);
		g2d.draw(youreHereLine);
		g2d.drawString("Du er her!", 465, 170);
	}

	public void setLocationCircle(int x, int y){
		circle = new Ellipse2D.Double(x,y,50,30);
		goalLine = new Line2D.Double(x+50, y+15, 465, y+15);
		goalText_y = y+5;
	}

	protected void clear(Graphics g){
		super.paintComponent(g);
	}

	protected Ellipse2D.Double getCircle(){
		return (circle);
	}
}